/**
 *  Copyright (c) 2021, Texas Instruments Incorporated
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  *   Redistributions of source code must retain the above copyright
 *  notice, this list of conditions and the following disclaimer.
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  *   Neither the name of Texas Instruments Incorporated nor the names of
 *  its contributors may be used to endorse or promote products derived
 *  from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 *  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 *  PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 *  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 *  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 *  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 *  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 *  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 *  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

import { Prop, Component, Element } from '@stencil/core';
import { GcGpioPinBaseProps } from '../gc-target-configuration/gc-gpio-pin-base-props';

/**
 * `gc-aevm-gpio-pin` is a non visual component for GPIO Pin for Analog EVM GPIO interface.
 *
 * @usage
 * @label AEVM GPIO Pin
 * @group Transports, Models, and Codecs
 */
@Component({
    tag: 'gc-aevm-gpio-pin',
    shadow: true
})

export class GcAevmGpioPin implements GcGpioPinBaseProps {
    /**
     * Open drain mode. Used when mode is output.
     *
     * @order 51
     */
    @Prop() openDrain = false;

    /**
     * Optional trigger type for interrupt pin.
     *
     * @order 52
     */
    @Prop() triggerType: 'rising' | 'falling' | 'bothEdge' | 'high' | 'low';

    // #region gc-target-configuration/gc-gpio-pin-base-props.tsx:
    // -----------Autogenerated - do not edit--------------
    /**
     * Pin number.
     *
     * @order 61
     */
    @Prop() pin: number;

    /**
     * Input or output mode.
     *
     * @order 62
     */
    @Prop() mode: 'output' | 'input';

    /**
     * State of output pin. Used when mode is output.
     *
     * @order 63
     */
    @Prop() state: 'high' | 'low';

    /**
     * Optional resistor state of input pin.  Used when mode is input.
     * Leave this property undefined for the case of no resistor.
     *
     * @order 64
     */
    @Prop() resistor?: 'pullup' | 'pulldown';

    @Element() el: HTMLElement;
    // #endregion

}
